]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
Merge branch 'jk/escaped-wildcard-dwim'
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
68cabbfd
DL
8USAGE="[--quiet] [--cached]
9 or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 10 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 11 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 12 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 13 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
b57e8119 14 or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
26b06100 15 or: $dashless [--quiet] set-url [--] <path> <newurl>
adc54235 16 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 17 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
18 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
19 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 20OPTIONS_SPEC=
091a6eb0 21SUBDIRECTORY_OK=Yes
70c7ac22 22. git-sh-setup
98fcf840 23. git-parse-remote
70c7ac22 24require_work_tree
091a6eb0
JK
25wt_prefix=$(git rev-parse --show-prefix)
26cd_to_toplevel
70c7ac22 27
f1762d77
BW
28# Tell the rest of git that any URLs we get don't come
29# directly from the user, so it can apply policy as appropriate.
30GIT_PROTOCOL_FROM_USER=0
31export GIT_PROTOCOL_FROM_USER
33cfccbb 32
5c08dbbd 33command=
ecda0723 34branch=
d27b876b 35force=
d92a3959 36reference=
70c7ac22 37cached=
48bb3033
GP
38recursive=
39init=
0060fd15 40require_init=
1c244f6e 41files=
06b1abb5 42remote=
31ca3ac3 43nofetch=
32948425 44update=
15fc56a8 45prefix=
73b0898d 46custom_name=
275cd184 47depth=
72c5f883 48progress=
a0ef2934 49dissociate=
70c7ac22 50
be9d0a3a
HV
51die_if_unmatched ()
52{
53 if test "$1" = "#unmatched"
54 then
c4c02bf1 55 exit ${2:-1}
be9d0a3a
HV
56 fi
57}
58
88ce00c3
TK
59#
60# Print a submodule configuration setting
61#
62# $1 = submodule name
63# $2 = option name
64# $3 = default value
65#
66# Checks in the usual git-config places first (for overrides),
67# otherwise it falls back on .gitmodules. This allows you to
68# distribute project-wide defaults in .gitmodules, while still
69# customizing individual repositories if necessary. If the option is
70# not in .gitmodules either, print a default value.
71#
72get_submodule_config () {
73 name="$1"
74 option="$2"
75 default="$3"
76 value=$(git config submodule."$name"."$option")
77 if test -z "$value"
78 then
b2faad44 79 value=$(git submodule--helper config submodule."$name"."$option")
88ce00c3
TK
80 fi
81 printf '%s' "${value:-$default}"
82}
83
862ae6cd
RS
84isnumber()
85{
86 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
87}
88
dda63468 89# Given a full hex object ID, is this the zero OID?
90is_zero_oid () {
91 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
92}
93
14111fc4
JK
94# Sanitize the local git environment for use within a submodule. We
95# can't simply use clear_local_git_env since we want to preserve some
96# of the settings from GIT_CONFIG_PARAMETERS.
97sanitize_submodule_env()
98{
89044baa 99 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 100 clear_local_git_env
89044baa 101 GIT_CONFIG_PARAMETERS=$save_config
860cba61 102 export GIT_CONFIG_PARAMETERS
14111fc4
JK
103}
104
ecda0723
SV
105#
106# Add a new submodule to the working tree, .gitmodules and the index
107#
ec05df35 108# $@ = repo path
ecda0723
SV
109#
110# optional branch is stored in global branch variable
111#
23a485e3 112cmd_add()
ecda0723 113{
5c08dbbd 114 # parse $args after "submodule ... add".
091a6eb0 115 reference_path=
5c08dbbd
JH
116 while test $# -ne 0
117 do
118 case "$1" in
119 -b | --branch)
120 case "$2" in '') usage ;; esac
121 branch=$2
122 shift
123 ;;
d27b876b
JL
124 -f | --force)
125 force=$1
126 ;;
5c08dbbd 127 -q|--quiet)
2e6a30ef 128 GIT_QUIET=1
5c08dbbd 129 ;;
6d33e1c2
CF
130 --progress)
131 progress=1
132 ;;
d92a3959
MT
133 --reference)
134 case "$2" in '') usage ;; esac
091a6eb0 135 reference_path=$2
d92a3959
MT
136 shift
137 ;;
138 --reference=*)
091a6eb0 139 reference_path="${1#--reference=}"
d92a3959 140 ;;
a0ef2934
CF
141 --dissociate)
142 dissociate=1
143 ;;
73b0898d
JL
144 --name)
145 case "$2" in '') usage ;; esac
146 custom_name=$2
147 shift
148 ;;
275cd184
FG
149 --depth)
150 case "$2" in '') usage ;; esac
151 depth="--depth=$2"
152 shift
153 ;;
154 --depth=*)
155 depth=$1
156 ;;
5c08dbbd
JH
157 --)
158 shift
159 break
160 ;;
161 -*)
162 usage
163 ;;
164 *)
165 break
166 ;;
167 esac
168 shift
169 done
170
76e9bdc4
AO
171 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
172 then
173 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
174 fi
175
091a6eb0
JK
176 if test -n "$reference_path"
177 then
178 is_absolute_path "$reference_path" ||
179 reference_path="$wt_prefix$reference_path"
180
181 reference="--reference=$reference_path"
182 fi
183
ecda0723 184 repo=$1
64394e3a 185 sm_path=$2
ecda0723 186
64394e3a 187 if test -z "$sm_path"; then
6a066230 188 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
189 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
190 fi
191
496eeeb1 192 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
193 usage
194 fi
195
091a6eb0
JK
196 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
197
ec05df35
ML
198 # assure repo is absolute or relative to parent
199 case "$repo" in
200 ./*|../*)
091a6eb0
JK
201 test -z "$wt_prefix" ||
202 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
203
ec05df35 204 # dereference source url relative to parent's url
63e95beb 205 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
206 ;;
207 *:*|/*)
208 # absolute url
209 realrepo=$repo
210 ;;
211 *)
497ee872 212 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
213 ;;
214 esac
215
db75ada5
MG
216 # normalize path:
217 # multiple //; leading ./; /./; /../; trailing /
64394e3a 218 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
219 sed -e '
220 s|//*|/|g
221 s|^\(\./\)*||
8196e728 222 s|/\(\./\)*|/|g
db75ada5
MG
223 :start
224 s|\([^/]*\)/\.\./||
225 tstart
226 s|/*$||
227 ')
619acfc7
SB
228 if test -z "$force"
229 then
230 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
231 die "$(eval_gettext "'\$sm_path' already exists in the index")"
232 else
233 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
234 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
235 fi
ecda0723 236
e1381118
KM
237 if test -d "$sm_path" &&
238 test -z $(git -C "$sm_path" rev-parse --show-cdup 2>/dev/null)
239 then
240 git -C "$sm_path" rev-parse --verify -q HEAD >/dev/null ||
241 die "$(eval_gettext "'\$sm_path' does not have a commit checked out")"
242 fi
243
c8163854 244 if test -z "$force"
d27b876b 245 then
c8163854
KM
246 dryerr=$(git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" 2>&1 >/dev/null)
247 res=$?
248 if test $res -ne 0
249 then
250 echo >&2 "$dryerr"
251 exit $res
252 fi
d27b876b
JL
253 fi
254
73b0898d
JL
255 if test -n "$custom_name"
256 then
257 sm_name="$custom_name"
258 else
259 sm_name="$sm_path"
260 fi
261
0383bbb9
JK
262 if ! git submodule--helper check-name "$sm_name"
263 then
264 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
265 fi
266
d4264ca3 267 # perhaps the path exists and is already a git repo, else clone it
64394e3a 268 if test -e "$sm_path"
d4264ca3 269 then
496eeeb1 270 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 271 then
64394e3a 272 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 273 else
64394e3a 274 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 275 fi
c2f93917 276
d4264ca3 277 else
4b7c286e
JL
278 if test -d ".git/modules/$sm_name"
279 then
280 if test -z "$force"
281 then
0d71dbfd 282 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 283 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
284 die "$(eval_gettextln "\
285If you want to reuse this local git directory instead of cloning again from
286 \$realrepo
287use the '--force' option. If the local git directory is not the correct repo
288or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 289 else
0d71dbfd 290 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
291 fi
292 fi
a0ef2934 293 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
d851ffb9 294 (
14111fc4 295 sanitize_submodule_env
d851ffb9
JH
296 cd "$sm_path" &&
297 # ash fails to wordsplit ${branch:+-b "$branch"...}
298 case "$branch" in
299 '') git checkout -f -q ;;
300 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
301 esac
302 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 303 fi
73b0898d 304 git config submodule."$sm_name".url "$realrepo"
d4264ca3 305
53213994 306 git add --no-warn-embedded-repo $force "$sm_path" ||
64394e3a 307 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 308
b2faad44
AO
309 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
310 git submodule--helper config submodule."$sm_name".url "$repo" &&
b9289227
TK
311 if test -n "$branch"
312 then
b2faad44 313 git submodule--helper config submodule."$sm_name".branch "$branch"
b9289227 314 fi &&
31991b02 315 git add --force .gitmodules ||
64394e3a 316 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
317
318 # NEEDSWORK: In a multi-working-tree world, this needs to be
319 # set in the per-worktree config.
320 if git config --get submodule.active >/dev/null
321 then
322 # If the submodule being adding isn't already covered by the
323 # current configured pathspec, set the submodule's active flag
324 if ! git submodule--helper is-active "$sm_path"
325 then
326 git config submodule."$sm_name".active "true"
327 fi
328 else
329 git config submodule."$sm_name".active "true"
330 fi
ecda0723
SV
331}
332
19a31f9c
ML
333#
334# Execute an arbitrary command sequence in each checked out
335# submodule
336#
337# $@ = command to execute
338#
339cmd_foreach()
340{
1d5bec8b
JH
341 # parse $args after "submodule ... foreach".
342 while test $# -ne 0
343 do
344 case "$1" in
345 -q|--quiet)
346 GIT_QUIET=1
347 ;;
15fc56a8
JH
348 --recursive)
349 recursive=1
350 ;;
1d5bec8b
JH
351 -*)
352 usage
353 ;;
354 *)
355 break
356 ;;
357 esac
358 shift
359 done
360
a282f5a9 361 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
19a31f9c
ML
362}
363
70c7ac22 364#
211b7f19 365# Register submodules in .git/config
70c7ac22
LH
366#
367# $@ = requested paths (default to all)
368#
23a485e3 369cmd_init()
70c7ac22 370{
5c08dbbd
JH
371 # parse $args after "submodule ... init".
372 while test $# -ne 0
373 do
374 case "$1" in
375 -q|--quiet)
2e6a30ef 376 GIT_QUIET=1
5c08dbbd
JH
377 ;;
378 --)
379 shift
380 break
381 ;;
382 -*)
383 usage
384 ;;
385 *)
386 break
387 ;;
388 esac
389 shift
390 done
391
a282f5a9 392 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} -- "$@"
70c7ac22
LH
393}
394
cf419828
JL
395#
396# Unregister submodules from .git/config and remove their work tree
397#
cf419828
JL
398cmd_deinit()
399{
400 # parse $args after "submodule ... deinit".
f6a52799 401 deinit_all=
cf419828
JL
402 while test $# -ne 0
403 do
404 case "$1" in
405 -f|--force)
406 force=$1
407 ;;
408 -q|--quiet)
409 GIT_QUIET=1
410 ;;
f6a52799
SB
411 --all)
412 deinit_all=t
413 ;;
cf419828
JL
414 --)
415 shift
416 break
417 ;;
418 -*)
419 usage
420 ;;
421 *)
422 break
423 ;;
424 esac
425 shift
426 done
427
a282f5a9 428 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} -- "$@"
cf419828
JL
429}
430
fb43e31f 431is_tip_reachable () (
01e1d544 432 sanitize_submodule_env &&
fb43e31f
SB
433 cd "$1" &&
434 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
435 test -z "$rev"
436)
437
438fetch_in_submodule () (
01e1d544 439 sanitize_submodule_env &&
fb43e31f
SB
440 cd "$1" &&
441 case "$2" in
442 '')
443 git fetch ;;
444 *)
6cbf454a
SB
445 shift
446 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
447 esac
448)
449
70c7ac22 450#
211b7f19 451# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
452#
453# $@ = requested paths (default to all)
454#
23a485e3 455cmd_update()
70c7ac22 456{
5c08dbbd
JH
457 # parse $args after "submodule ... update".
458 while test $# -ne 0
459 do
460 case "$1" in
461 -q|--quiet)
2e6a30ef 462 GIT_QUIET=1
5c08dbbd 463 ;;
e84c3cf3
SB
464 -v)
465 GIT_QUIET=0
466 ;;
72c5f883 467 --progress)
c7199e3a 468 progress=1
72c5f883 469 ;;
be4d2c83 470 -i|--init)
d92a3959 471 init=1
be4d2c83 472 ;;
0060fd15
JS
473 --require-init)
474 init=1
475 require_init=1
476 ;;
06b1abb5
TK
477 --remote)
478 remote=1
479 ;;
31ca3ac3 480 -N|--no-fetch)
31ca3ac3
FF
481 nofetch=1
482 ;;
9db31bdf
NMC
483 -f|--force)
484 force=$1
485 ;;
ca2cedba 486 -r|--rebase)
32948425 487 update="rebase"
ca2cedba 488 ;;
d92a3959
MT
489 --reference)
490 case "$2" in '') usage ;; esac
491 reference="--reference=$2"
98dbe63d 492 shift
d92a3959
MT
493 ;;
494 --reference=*)
495 reference="$1"
d92a3959 496 ;;
a0ef2934
CF
497 --dissociate)
498 dissociate=1
499 ;;
42b49178 500 -m|--merge)
42b49178
JH
501 update="merge"
502 ;;
b13fd5c1 503 --recursive)
b13fd5c1
JH
504 recursive=1
505 ;;
efc5fb6a
JH
506 --checkout)
507 update="checkout"
508 ;;
abed000a
SB
509 --recommend-shallow)
510 recommend_shallow="--recommend-shallow"
511 ;;
512 --no-recommend-shallow)
513 recommend_shallow="--no-recommend-shallow"
514 ;;
275cd184
FG
515 --depth)
516 case "$2" in '') usage ;; esac
517 depth="--depth=$2"
518 shift
519 ;;
520 --depth=*)
521 depth=$1
522 ;;
2335b870
SB
523 -j|--jobs)
524 case "$2" in '') usage ;; esac
525 jobs="--jobs=$2"
526 shift
527 ;;
528 --jobs=*)
529 jobs=$1
530 ;;
5c08dbbd
JH
531 --)
532 shift
533 break
534 ;;
535 -*)
536 usage
537 ;;
538 *)
539 break
540 ;;
541 esac
98dbe63d 542 shift
5c08dbbd
JH
543 done
544
d92a3959
MT
545 if test -n "$init"
546 then
547 cmd_init "--" "$@" || return
548 fi
549
48308681
SB
550 {
551 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
c7199e3a 552 ${progress:+"--progress"} \
48308681
SB
553 ${wt_prefix:+--prefix "$wt_prefix"} \
554 ${prefix:+--recursive-prefix "$prefix"} \
555 ${update:+--update "$update"} \
5f50f33e 556 ${reference:+"$reference"} \
a0ef2934 557 ${dissociate:+"--dissociate"} \
48308681 558 ${depth:+--depth "$depth"} \
0060fd15 559 ${require_init:+--require-init} \
c7199e3a
CF
560 $recommend_shallow \
561 $jobs \
a282f5a9 562 -- \
c4c02bf1 563 "$@" || echo "#unmatched" $?
48308681 564 } | {
15ffb7cd 565 err=
9eca701f 566 while read -r quickabort sha1 just_cloned sm_path
70c7ac22 567 do
9eca701f 568 die_if_unmatched "$quickabort" "$sha1"
48308681 569
5d124f41 570 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
74d4731d 571
ee69b2a9 572 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
efc5fb6a 573
44431df0 574 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 575
48308681 576 if test $just_cloned -eq 1
d851ffb9 577 then
bf2d8246
LH
578 subsha1=
579 else
14111fc4 580 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 581 git rev-parse --verify HEAD) ||
091a6eb0 582 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 583 fi
211b7f19 584
06b1abb5
TK
585 if test -n "$remote"
586 then
92bbe7cc 587 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
588 if test -z "$nofetch"
589 then
590 # Fetch remote before determining tracking $sha1
6cbf454a 591 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
592 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
593 fi
14111fc4
JK
594 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
595 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 596 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 597 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
598 fi
599
496eeeb1 600 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 601 then
9db31bdf
NMC
602 subforce=$force
603 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 604 if test -z "$subsha1" && test -z "$force"
b9b378a0 605 then
9db31bdf 606 subforce="-f"
b9b378a0 607 fi
31ca3ac3
FF
608
609 if test -z "$nofetch"
610 then
e5f522d6
JL
611 # Run fetch only if $sha1 isn't present or it
612 # is not reachable from a ref.
fb43e31f 613 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 614 fetch_in_submodule "$sm_path" $depth ||
bd5e567d 615 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'; trying to directly fetch \$sha1:")"
fb43e31f
SB
616
617 # Now we tried the usual fetch, but $sha1 may
618 # not be reachable from any of the refs
619 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 620 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 621 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
622 fi
623
877449c1 624 must_die_on_failure=
32948425 625 case "$update_module" in
a2aed08b
TK
626 checkout)
627 command="git checkout $subforce -q"
628 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
629 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
630 ;;
32948425
JH
631 rebase)
632 command="git rebase"
091a6eb0
JK
633 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
634 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 635 must_die_on_failure=yes
32948425 636 ;;
42b49178
JH
637 merge)
638 command="git merge"
091a6eb0
JK
639 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
640 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 641 must_die_on_failure=yes
42b49178 642 ;;
6cb5728c
CP
643 !*)
644 command="${update_module#!}"
b08238ac
SB
645 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
646 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
647 must_die_on_failure=yes
648 ;;
32948425 649 *)
ff03d930 650 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
32948425 651 esac
70c7ac22 652
14111fc4 653 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 654 then
ff968f03 655 say "$say_msg"
877449c1
JH
656 elif test -n "$must_die_on_failure"
657 then
ff968f03 658 die_with_status 2 "$die_msg"
15ffb7cd 659 else
ff968f03 660 err="${err};$die_msg"
877449c1 661 continue
15ffb7cd 662 fi
70c7ac22 663 fi
b13fd5c1
JH
664
665 if test -n "$recursive"
666 then
75bf5e60 667 (
44431df0 668 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 669 wt_prefix=
14111fc4 670 sanitize_submodule_env
75bf5e60 671 cd "$sm_path" &&
36141282 672 eval cmd_update
75bf5e60 673 )
15ffb7cd
FG
674 res=$?
675 if test $res -gt 0
676 then
091a6eb0 677 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 678 if test $res -ne 2
15ffb7cd 679 then
ff968f03 680 err="${err};$die_msg"
15ffb7cd
FG
681 continue
682 else
ff968f03 683 die_with_status $res "$die_msg"
15ffb7cd
FG
684 fi
685 fi
b13fd5c1 686 fi
70c7ac22 687 done
15ffb7cd
FG
688
689 if test -n "$err"
690 then
691 OIFS=$IFS
692 IFS=';'
693 for e in $err
694 do
695 if test -n "$e"
696 then
697 echo >&2 "$e"
698 fi
699 done
700 IFS=$OIFS
701 exit 1
702 fi
703 }
70c7ac22
LH
704}
705
b57e8119
DL
706#
707# Configures a submodule's default branch
708#
709# $@ = requested path
710#
711cmd_set_branch() {
712 unset_branch=false
713 branch=
714
715 while test $# -ne 0
716 do
717 case "$1" in
718 -q|--quiet)
719 # we don't do anything with this but we need to accept it
720 ;;
721 -d|--default)
722 unset_branch=true
723 ;;
724 -b|--branch)
725 case "$2" in '') usage ;; esac
726 branch=$2
727 shift
728 ;;
729 --)
730 shift
731 break
732 ;;
733 -*)
734 usage
735 ;;
736 *)
737 break
738 ;;
739 esac
740 shift
741 done
742
743 if test $# -ne 1
744 then
745 usage
746 fi
747
748 # we can't use `git submodule--helper name` here because internally, it
749 # hashes the path so a trailing slash could lead to an unintentional no match
750 name="$(git submodule--helper list "$1" | cut -f2)"
751 if test -z "$name"
752 then
753 exit 1
754 fi
755
756 test -n "$branch"; has_branch=$?
757 test "$unset_branch" = true; has_unset_branch=$?
758
759 if test $((!$has_branch != !$has_unset_branch)) -eq 0
760 then
761 usage
762 fi
763
764 if test $has_branch -eq 0
765 then
766 git submodule--helper config submodule."$name".branch "$branch"
767 else
768 git submodule--helper config --unset submodule."$name".branch
769 fi
770}
771
26b06100
DL
772#
773# Configures a submodule's remote url
774#
775# $@ = requested path, requested url
776#
777cmd_set_url() {
778 while test $# -ne 0
779 do
780 case "$1" in
781 -q|--quiet)
782 GIT_QUIET=1
783 ;;
784 --)
785 shift
786 break
787 ;;
788 -*)
789 usage
790 ;;
791 *)
792 break
793 ;;
794 esac
795 shift
796 done
797
798 if test $# -ne 2
799 then
800 usage
801 fi
802
803 # we can't use `git submodule--helper name` here because internally, it
804 # hashes the path so a trailing slash could lead to an unintentional no match
805 name="$(git submodule--helper list "$1" | cut -f2)"
806 if test -z "$name"
807 then
808 exit 1
809 fi
810
811 url="$2"
812 if test -z "$url"
813 then
814 exit 1
815 fi
816
817 git submodule--helper config submodule."$name".url "$url"
818 git submodule--helper sync ${GIT_QUIET:+--quiet} "$name"
819}
820
28f9af5d
PY
821#
822# Show commit summary for submodules in index or working tree
823#
824# If '--cached' is given, show summary between index and given commit,
825# or between working tree and given commit
826#
827# $@ = [commit (default 'HEAD'),] requested paths (default all)
828#
829cmd_summary() {
f2dc06a3 830 summary_limit=-1
d0f64dd4 831 for_status=
1c244f6e 832 diff_cmd=diff-index
f2dc06a3 833
28f9af5d
PY
834 # parse $args after "submodule ... summary".
835 while test $# -ne 0
836 do
837 case "$1" in
838 --cached)
839 cached="$1"
840 ;;
1c244f6e
JL
841 --files)
842 files="$1"
843 ;;
d0f64dd4
PY
844 --for-status)
845 for_status="$1"
846 ;;
f2dc06a3 847 -n|--summary-limit)
862ae6cd
RS
848 summary_limit="$2"
849 isnumber "$summary_limit" || usage
f2dc06a3
PY
850 shift
851 ;;
862ae6cd
RS
852 --summary-limit=*)
853 summary_limit="${1#--summary-limit=}"
854 isnumber "$summary_limit" || usage
855 ;;
28f9af5d
PY
856 --)
857 shift
858 break
859 ;;
860 -*)
861 usage
862 ;;
863 *)
864 break
865 ;;
866 esac
867 shift
868 done
bffe71f4 869
f2dc06a3
PY
870 test $summary_limit = 0 && return
871
3deea89c 872 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
873 then
874 head=$rev
caa9c3ca 875 test $# = 0 || shift
496eeeb1 876 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 877 then
14e940d7
JH
878 # before the first commit: compare with an empty tree
879 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 880 test -z "$1" || shift
28f9af5d 881 else
3deea89c 882 head="HEAD"
28f9af5d
PY
883 fi
884
1c244f6e
JL
885 if [ -n "$files" ]
886 then
887 test -n "$cached" &&
465d6a00 888 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
889 diff_cmd=diff-files
890 head=
891 fi
892
28f9af5d 893 cd_to_toplevel
091a6eb0 894 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 895 # Get modified modules cared by user
18076502 896 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 897 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 898 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
899 do
900 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
901 if test "$status" = D || test "$status" = T
902 then
6a066230 903 printf '%s\n' "$sm_path"
496eeeb1
EP
904 continue
905 fi
927b26f8 906 # Respect the ignore setting for --for-status.
907 if test -n "$for_status"
908 then
0ea306ef 909 name=$(git submodule--helper name "$sm_path")
927b26f8 910 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 911 test $status != A && test $ignore_config = all && continue
927b26f8 912 fi
28f9af5d 913 # Also show added or modified modules which are checked out
974ce807 914 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 915 printf '%s\n' "$sm_path"
28f9af5d
PY
916 done
917 )
1cb639e6 918
d0f64dd4
PY
919 test -z "$modules" && return
920
18076502 921 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 922 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 923 cut -c2- |
cf9e55f4 924 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
925 do
926 if test -z "$cached" &&
dda63468 927 is_zero_oid $sha1_dst
1cb639e6
PY
928 then
929 case "$mod_dst" in
930 160000)
931 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
932 ;;
933 100644 | 100755 | 120000)
934 sha1_dst=$(git hash-object $name)
935 ;;
936 000000)
937 ;; # removed
938 *)
939 # unexpected type
6ff875c5 940 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
941 continue ;;
942 esac
943 fi
944 missing_src=
945 missing_dst=
946
947 test $mod_src = 160000 &&
974ce807 948 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
949 missing_src=t
950
951 test $mod_dst = 160000 &&
974ce807 952 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 953 missing_dst=t
bffe71f4 954
44431df0 955 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 956
1cb639e6
PY
957 total_commits=
958 case "$missing_src,$missing_dst" in
959 t,)
091a6eb0 960 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
961 ;;
962 ,t)
091a6eb0 963 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
964 ;;
965 t,t)
091a6eb0 966 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
967 ;;
968 *)
969 errmsg=
970 total_commits=$(
496eeeb1 971 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
972 then
973 range="$sha1_src...$sha1_dst"
974 elif test $mod_src = 160000
975 then
976 range=$sha1_src
977 else
978 range=$sha1_dst
979 fi
980 GIT_DIR="$name/.git" \
b0e621ad 981 git rev-list --first-parent $range -- | wc -l
1cb639e6 982 )
eed35595 983 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
984 ;;
985 esac
986
0586a438
SH
987 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
988 echo $sha1_src | cut -c1-7)
989 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
990 echo $sha1_dst | cut -c1-7)
991
1cb639e6
PY
992 if test $status = T
993 then
b3e73449
ÆAB
994 blob="$(gettext "blob")"
995 submodule="$(gettext "submodule")"
1cb639e6
PY
996 if test $mod_dst = 160000
997 then
091a6eb0 998 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 999 else
091a6eb0 1000 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
1001 fi
1002 else
091a6eb0 1003 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
1004 fi
1005 if test -n "$errmsg"
1006 then
1007 # Don't give error msg for modification whose dst is not submodule
1008 # i.e. deleted or changed to blob
1009 test $mod_dst = 160000 && echo "$errmsg"
1010 else
496eeeb1 1011 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 1012 then
f2dc06a3
PY
1013 limit=
1014 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 1015 GIT_DIR="$name/.git" \
f2dc06a3 1016 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
1017 --first-parent $sha1_src...$sha1_dst
1018 elif test $mod_dst = 160000
1019 then
1020 GIT_DIR="$name/.git" \
1021 git log --pretty='format: > %s' -1 $sha1_dst
1022 else
1023 GIT_DIR="$name/.git" \
1024 git log --pretty='format: < %s' -1 $sha1_src
1025 fi
1026 echo
1027 fi
1028 echo
3ba7407b 1029 done
28f9af5d 1030}
70c7ac22 1031#
941987a5 1032# List all submodules, prefixed with:
70c7ac22
LH
1033# - submodule not initialized
1034# + different revision checked out
1035#
1036# If --cached was specified the revision in the index will be printed
1037# instead of the currently checked out revision.
1038#
1039# $@ = requested paths (default to all)
1040#
23a485e3 1041cmd_status()
70c7ac22 1042{
5c08dbbd
JH
1043 # parse $args after "submodule ... status".
1044 while test $# -ne 0
1045 do
1046 case "$1" in
1047 -q|--quiet)
2e6a30ef 1048 GIT_QUIET=1
5c08dbbd
JH
1049 ;;
1050 --cached)
1051 cached=1
1052 ;;
64b19ffe
JH
1053 --recursive)
1054 recursive=1
1055 ;;
5c08dbbd
JH
1056 --)
1057 shift
1058 break
1059 ;;
1060 -*)
1061 usage
1062 ;;
1063 *)
1064 break
1065 ;;
1066 esac
1067 shift
1068 done
1069
a282f5a9 1070 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} -- "$@"
70c7ac22 1071}
2327f61e
DA
1072#
1073# Sync remote urls for submodules
1074# This makes the value for remote.$remote.url match the value
1075# specified in .gitmodules.
1076#
1077cmd_sync()
1078{
1079 while test $# -ne 0
1080 do
1081 case "$1" in
1082 -q|--quiet)
2e6a30ef 1083 GIT_QUIET=1
2327f61e
DA
1084 shift
1085 ;;
82f49f29
PH
1086 --recursive)
1087 recursive=1
1088 shift
1089 ;;
2327f61e
DA
1090 --)
1091 shift
1092 break
1093 ;;
1094 -*)
1095 usage
1096 ;;
1097 *)
1098 break
1099 ;;
1100 esac
1101 done
e7849a96 1102
a282f5a9 1103 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
2327f61e 1104}
70c7ac22 1105
f6f85861
SB
1106cmd_absorbgitdirs()
1107{
1108 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1109}
1110
5c08dbbd
JH
1111# This loop parses the command line arguments to find the
1112# subcommand name to dispatch. Parsing of the subcommand specific
1113# options are primarily done by the subcommand implementations.
1114# Subcommand specific options such as --branch and --cached are
1115# parsed here as well, for backward compatibility.
1116
1117while test $# != 0 && test -z "$command"
70c7ac22
LH
1118do
1119 case "$1" in
26b06100 1120 add | foreach | init | deinit | update | set-branch | set-url | status | summary | sync | absorbgitdirs)
5c08dbbd 1121 command=$1
70c7ac22
LH
1122 ;;
1123 -q|--quiet)
2e6a30ef 1124 GIT_QUIET=1
70c7ac22 1125 ;;
ecda0723
SV
1126 -b|--branch)
1127 case "$2" in
1128 '')
1129 usage
1130 ;;
1131 esac
1132 branch="$2"; shift
1133 ;;
70c7ac22 1134 --cached)
28f9af5d 1135 cached="$1"
70c7ac22
LH
1136 ;;
1137 --)
1138 break
1139 ;;
1140 -*)
1141 usage
1142 ;;
1143 *)
1144 break
1145 ;;
1146 esac
1147 shift
1148done
1149
5c08dbbd 1150# No command word defaults to "status"
af9c9f97
RR
1151if test -z "$command"
1152then
1153 if test $# = 0
1154 then
1155 command=status
1156 else
1157 usage
1158 fi
1159fi
5c08dbbd 1160
b57e8119
DL
1161# "-b branch" is accepted only by "add" and "set-branch"
1162if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
5c08dbbd 1163then
ecda0723 1164 usage
5c08dbbd
JH
1165fi
1166
28f9af5d 1167# "--cached" is accepted only by "status" and "summary"
496eeeb1 1168if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1169then
70c7ac22 1170 usage
5c08dbbd
JH
1171fi
1172
b57e8119 1173"cmd_$(echo $command | sed -e s/-/_/g)" "$@"